program xydata;
uses crt;
const
        maxrec   = 500;
        min_date = 800420;
        max_date = 820101;
        xsource  =   285.66;
        ysource  =  4385.10;
var
        date,idate,pldate,lastdate,ii,day,mth,yr     : longint;
        i,irec,nrec,hr,plot_ok,plhour,cc             : integer;
        xx,yy,dummy,recid,dist                       : single;
        x,y,z               : array[1..maxrec] of single;
        c                   : array[1..maxrec,1..24] of single;
        name,streng         : string ;
        ch1                 : string[1] ;
        infile,outfile      : text;
        data_emty           : Boolean;

begin
  clrscr;
  writeln('---------------------------------------------------------');
  writeln('  Read x,y-coordinates and concentrations from Kincaid   ');
  writeln('  and output one hour in file "YYMMDDHR".DAT in          ');
  writeln('  GRAPHER input format.                                  ');
  writeln('---------------------------------------------------------');
  writeln;
  write('  Enter input file name: ');
  readln(name);
  assign(infile,name);
  reset(infile);
  lastdate := min_date;
  repeat;
    repeat;
      write('  Enter date [yymmdd] for plot (stop=0): ');
      readln(pldate);
      plot_ok := 1;
      if (pldate<min_date) or (pldate>max_date) then begin
          writeln('   Wrong date !!!');
          plot_ok := 0;
      end;
    until (eof(infile)) or (pldate=0) or (plot_ok=1);
    if (pldate=0) then halt;
    if (lastdate>=pldate) then reset(infile);
    repeat;
      readln(infile,idate,dummy,nrec);
      {format idate: mmddyy}
      mth := idate div 10000;
      day := idate div 100 - mth*100;
      yr  := idate - day*100 - mth*10000;
      date := yr*10000+mth*100+day;
      writeln('  Date: ',date:6);
      if (date=pldate) then begin
        for irec := 1 to nrec do begin
          read(infile,recid,x[irec],y[irec],z[irec]);
          for hr := 1 to 12 do
            read(infile,c[irec,hr]);
          readln(infile);
          for hr := 13 to 24 do
            read(infile,c[irec,hr]);
          readln(infile);
        end;
      end else if (date>pldate) then begin
        writeln(' Date not found !!!');
        pldate := 0;
      end else begin
        for i := 1 to 2*nrec do
          readln(infile);
      end;
    until (pldate=date) or (eof(infile)) or (pldate=0);
    if (pldate>date) then begin
       writeln('   Date not found.  End of file !!!');
       pldate := 0;
    end;
    lastdate := date;
    if (date=pldate) then begin
      repeat;
        write('    Enter hour (1..24) for plot (stop= 0): ');
        readln(plhour);
        if (plhour>0) and (plhour<25) then begin
          str(date:6,name);
          if (plhour<10) then begin
            str(plhour:1,streng);
            streng := name+'0'+streng+'.dat';
          end else begin
            str(plhour:2,streng);
            streng := name+streng+'.dat';
          end;

          data_emty := true;
          for irec := 1 to nrec do begin
            cc := round(c[irec,plhour]);
            if cc>-0.01 then data_emty := false;
          end;
          if not data_emty then begin
            assign(outfile,streng);
            rewrite(outfile);
            for irec := 1 to nrec do begin
              cc := round(c[irec,plhour]);
              if cc>-0.01 then begin
                xx := x[irec] - xsource;
                yy := y[irec] - ysource;
                dist := sqrt(xx*xx+yy*yy);
                if (cc<10) then begin
                 writeln(outfile,xx:7:2,yy:7:2,' "',cc:1,'" ""   "" ',dist:7:2);
                end else if (cc<100) then begin
                 writeln(outfile,xx:7:2,yy:7:2,' ""  "',cc:2,'" ""  ',dist:7:2);
                end else if (cc<1000) then begin
                 writeln(outfile,xx:7:2,yy:7:2,' ""  "" "',cc:3,'"  ',dist:7:2);
                end else if (cc<10000) then begin
                 writeln(outfile,xx:7:2,yy:7:2,' "" "" "" "',cc:4,'" ',dist:7:2);
                end;
              end;
            end;
            { Source position}
            writeln(outfile,'   0.00   0.00 ""  ""  "*"    0.00 "Source" Date:',
                            date:7,'  Hour:',plhour:3);
            close(outfile);
          end else
            writeln('   No usable data !!!');
          write('    Plot another hour ? (y/n): ');
          readln(ch1);
        end;
      until (ch1='n') or (ch1='N') or (plhour=0);
    end;
    write('  Plot another date ? (y/n): ');
    readln(ch1);
  until (ch1='n') or (ch1='N');
  close(infile);
end.
